=== debian/changelog ===
grafx2 (2.2-1) unstable; urgency=low

  * New upstream version, fixes FTBFS with binutils-gold. (Closes: #554742)
  * Bump standards version to 3.8.4.
  * debian/control: Add liblua5.1-0-dev and pkg-config to build depends.
  * debian/rules: Drop dh_desktop call.
  * debian/copyright: Update years.
  * Switch to dpkg-source format version 3.0 (quilt).
  * debian/watch: Added.
  * Added patch to fix spelling errors in source code.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Mon, 22 Mar 2010 12:07:47 +0100

grafx2 (2.1-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Mon, 21 Sep 2009 14:24:19 +0200

grafx2 (2.0-1) unstable; urgency=low

  * New upstream version.
  * Drop manual page since it comes with upstream now.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Wed, 10 Jun 2009 10:44:35 +0200

grafx2 (2+20090319-1) unstable; urgency=low

  * Initial release. (Closes: #516724)

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Thu, 19 Mar 2009 12:15:06 +0100
