=== debian/watch ===
version=3
opts="uversionmangle=s/\.\d+$//" \
http://code.google.com/p/grafx2/downloads/list http://grafx2.googlecode.com/files/grafx2-([\d\.]+)-src\.tgz
